Components.utils.import('chrome://acewebextension-modules/content/util.js');

var AWE_ContextMenuCommander = {
    popup: null,
    cookieShowing: null,
    menuCommands: {},
    messageCookie: 1,
};


AWE_ContextMenuCommander.initialize = function() {
    var ppmm = Components
        .classes["@mozilla.org/parentprocessmessagemanager;1"]
        .getService(Components.interfaces.nsIMessageListenerManager);
    ppmm.addMessageListener('acewebextension:context-menu-command-response',
        AWE_ContextMenuCommander.messageMenuCommandResponse);
};


AWE_ContextMenuCommander.commandClicked = function(aCommand) {
    var url = null;
    if(gContextMenu.onLink) {
        url = gContextMenu.linkURL;
    }
    gBrowser.selectedBrowser.messageManager.sendAsyncMessage(
        'acewebextension:context-menu-command-run',
        {'cookie': aCommand.cookie, 'scriptUuid': aCommand.scriptUuid, 'url': url});
};


AWE_ContextMenuCommander.createMenuItem = function(command) {
    var menuItem = document.createElement("menuitem");
    menuItem.className = "acewebextension-custom-context-menu";
    menuItem.setAttribute("label", command.name);
    menuItem.setAttribute("tooltiptext", command.scriptName);
    menuItem.addEventListener("command", function() {
            AWE_ContextMenuCommander.commandClicked(command);
    }, false);
    
    if (command.accessKey) {
        menuItem.setAttribute("accesskey", command.accessKey);
    }
    
    return menuItem;
};


AWE_ContextMenuCommander.messageMenuCommandResponse = function(aMessage) {
    console.log("AWE_ContextMenuCommander.messageMenuCommandResponse", aMessage.data);
    if (aMessage.data.cookie != AWE_ContextMenuCommander.cookieShowing) return;
    
    for (i in aMessage.data.commands) {
        var command = aMessage.data.commands[i];
        var menuItem = AWE_ContextMenuCommander.createMenuItem(command);
        AWE_ContextMenuCommander.popup.appendChild(menuItem);
    }
};


AWE_ContextMenuCommander.onPopupHiding = function() {
    // Asynchronously.  See #1632.
    AWE_util.timeout(function() {
            var i, customItems = AWE_ContextMenuCommander.popup.querySelectorAll('.acewebextension-custom-context-menu');
            for(i = 0; i < customItems.length; i++) {
                customItems[i].parentNode.removeChild(customItems[i]);
            }
    }, 0);
};


AWE_ContextMenuCommander.onPopupShowing = function(aEvent) {
    AWE_ContextMenuCommander.popup = aEvent.target;
    AWE_ContextMenuCommander.messageCookie++;
    AWE_ContextMenuCommander.cookieShowing = AWE_ContextMenuCommander.messageCookie;
    
    var url = null;
    if(gContextMenu.onLink) {
        url = gContextMenu.linkURL;
    }
    
    // Ask the selected browser to fill up our context menu.
    gBrowser.selectedBrowser.messageManager.sendAsyncMessage(
        'acewebextension:context-menu-command-list',
        {
            cookie: AWE_ContextMenuCommander.cookieShowing,
            url: url
        });
};
