Components.utils.import('chrome://acewebextension-modules/content/util.js');

var AWE_MenuCommander = {
  popup: null,
  cookieShowing: null,
  menuCommands: {},
  messageCookie: 1,
};


AWE_MenuCommander.initialize = function() {
  var ppmm = Components
      .classes["@mozilla.org/parentprocessmessagemanager;1"]
      .getService(Components.interfaces.nsIMessageListenerManager);
  ppmm.addMessageListener('acewebextension:menu-command-response',
      AWE_MenuCommander.messageMenuCommandResponse);
};


AWE_MenuCommander.commandClicked = function(aCommand) {
  gBrowser.selectedBrowser.messageManager.sendAsyncMessage(
      'acewebextension:menu-command-run',
      {'cookie': aCommand.cookie, 'scriptUuid': aCommand.scriptUuid});
};


AWE_MenuCommander.createMenuItem = function(command) {
  var menuItem = document.createElement("menuitem");
  menuItem.setAttribute("label", command.name);
  menuItem.setAttribute("tooltiptext", command.scriptName);
  menuItem.addEventListener("command", function() {
    AWE_MenuCommander.commandClicked(command);
  }, false);

  if (command.accessKey) {
      menuItem.setAttribute("accesskey", command.accessKey);
  }

  return menuItem;
};


AWE_MenuCommander.messageMenuCommandResponse = function(aMessage) {
  if (aMessage.data.cookie != AWE_MenuCommander.cookieShowing) return;

  AWE_MenuCommander.popup.parentNode.disabled = false;
  for (i in aMessage.data.commands) {
    var command = aMessage.data.commands[i];
    var menuItem = AWE_MenuCommander.createMenuItem(command);
    AWE_MenuCommander.popup.appendChild(menuItem);
  }
};


AWE_MenuCommander.onPopupHiding = function() {
  // Asynchronously.  See #1632.
  AWE_util.timeout(function() { AWE_util.emptyEl(AWE_MenuCommander.popup); }, 0);
};


AWE_MenuCommander.onPopupShowing = function(aEvent) {
  if (!AWE_MenuCommander.popup) {
    AWE_MenuCommander.popup = aEvent.target.querySelector(
        'menupopup.acewebextension-user-script-commands-popup');
  }

  AWE_MenuCommander.messageCookie++;
  AWE_MenuCommander.cookieShowing = AWE_MenuCommander.messageCookie;

  // Start disabled and empty ...
  AWE_MenuCommander.popup.parentNode.disabled = true;
  AWE_util.emptyEl(AWE_MenuCommander.popup);
  // ... ask the selected browser to fill up our menu.
  gBrowser.selectedBrowser.messageManager.sendAsyncMessage(
      'acewebextension:menu-command-list',
      {'cookie': AWE_MenuCommander.cookieShowing});
};
