Components.utils.import('chrome://acewebextension-modules/content/GM_notification.js');
Components.utils.import('chrome://acewebextension-modules/content/parseScript.js');
Components.utils.import('chrome://acewebextension-modules/content/remoteScript.js');
Components.utils.import('chrome://acewebextension-modules/content/util.js');

var EXPORTED_SYMBOLS = ['installScriptFromSource'];

var gCouldNotDownloadString = Components
    .classes["@mozilla.org/intl/stringbundle;1"]
    .getService(Components.interfaces.nsIStringBundleService)
    .createBundle("chrome://acewebextension/locale/acewebextension.properties")
    .GetStringFromName('error.could-not-download-dependencies');

function installScriptFromSource(aSource, aCallback) {
  var remoteScript = new RemoteScript();
  var script = parse(aSource);
  var tempFileName = cleanFilename(script.name, 'awe_script') + '.acestream.js';
  var tempFile = AWE_util.getTempFile(remoteScript._tempDir, tempFileName);
  AWE_util.writeToFile(aSource, tempFile, function() {
    remoteScript.setScript(script, tempFile);
    remoteScript.download(function(aSuccess) {
      if (!aSuccess) {
        GM_notification(
            gCouldNotDownloadString.replace('%1', remoteScript.errorMessage),
            'dependency-download-failed');
        return;
      }
      remoteScript.install();
      AWE_util.openInEditor(script);
      if (aCallback) aCallback();
    });
  });
}
